<template>
    <div class="content">
        <div class="intro-y flex flex-col sm:flex-row items-center my-8">
            <div class="mr-auto">
                <h2 class="text-lg font-medium mr-auto">
                    Management Participant
                </h2>
            </div>
        </div>
        <div class="grid grid-cols-12 gap-6 mt-5">
            <div class="intro-y col-span-12 lg:col-span-6">
                <!-- BEGIN: Form Layout -->
                <div class="intro-x box p-5">
                    <form @submit.prevent="submit">
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Name</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Name"
                                v-model="name">
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Email</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Email"
                                v-model="email">
                        </div>
                        
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Department</label>
                            <select class="tom-select w-full" v-model="department" data-placeholder="Select Department">
                                <option v-for="item in departments" :value="item" :key="item">{{item}}</option>
                            </select>
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Level</label>
                            <select class="tom-select w-full" v-model="level" data-placeholder="Select Role">
                                <option v-for="item in levels" :value="item" :key="item">{{item}}</option>
                            </select>
                        </div>
                        <div class="text-right mt-5">
                            <a type="button" class="btn btn-outline-secondary w-24 mr-1"
                              href="/participant">Cancel</a>
                            <button type="submit" class="btn btn-primary w-24">{{label}}</button>
                        </div>
                    </form>
                </div>
                <!-- END: Form Layout -->
            </div>
        </div>
    </div>
</template>

<script>
    import Toastify from 'toastify-js';

    export default {
        name: 'FormUser',
        data() {
            return {
                username: "",
                password: "",
                email: "",
                name: "",
                roles: ["admin", "user", "head department"],
                role: "",
                levels: [],
                level: "",
                departments: [],
                department: "",
                file: "",
                edit: false,
                label: "Save",
                fieldEmpty: [],
                error: "",
                id: 0,
                user: null
            }
        },
        created: function () {
            var splitUrl = this.$route.path.split("/");
            if (splitUrl[1] == "edit-participant") {
                this.edit = true
                this.id = splitUrl[2]
                this.label = "Edit"
            }
            this.getDepartment()
            this.getLevel()
        },
        methods: {
            async getDepartment() {
                const res = await this.$axios.get("/organizer/code", {
                    headers: {
                        "Token": this.$store.state.user.token,
                        "User-ID": this.$store.state.user.user_id
                    }
                })
                let data = res.data.data
                for (let x = 0; x < data.length; x++) {
                    const element = data[x];
                    this.departments.push(element.name)
                }
            },
            async getLevel() {
                const res = await this.$axios.get("/role/code", {
                    headers: {
                        "Token": this.$store.state.user.token,
                        "User-ID": this.$store.state.user.user_id
                    }
                })
                let data = res.data.data
                for (let x = 0; x < data.length; x++) {
                    const element = data[x];
                    this.levels.push(element.name)
                }
            },
            async getDetail() {
                this.$axios.get(`/participant/${this.id}/detail`, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    })
                    .then((response) => {
                        const data = response.data.data

                        if (this.departments.find(x => x != data.organizer)) {
                            this.departments.push(data.organizer)
                        }

                        if (this.levels.find(x => x != data.level)) {
                            this.levels.push(data.level)
                        }

                        this.user = data
                        this.email = data.email
                        this.name = data.name
                        this.department = data.organizer
                        this.level = data.level
                    }).catch(error => {
                        console.log(error);
                    });
            },
            handleFileUpload() {
                this.file = this.$refs.file.files[0];
            },
            reset() {
                this.email = this.user.email
                this.name = this.user.name
                this.department = data.organizer
                this.level = data.level
            },
            submit: function () {
                if (this.email == "") {
                    this.fieldEmpty.push('email')
                }

                if (this.name == "") {
                    this.fieldEmpty.push('name')
                }

                if (this.department == "") {
                    this.fieldEmpty.push('department')
                }


                if (this.level == "") {
                    this.fieldEmpty.push('level')
                }

                let body = {
                    "name" : this.name,
                    "email" : this.email,
                    "organizer" : this.department,
                    "level" :this .level
                }
                if (this.edit) {
                   

                    this.$axios.put(`/participant/${this.id}/update`, body, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Update User Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                        this.$router.push({
                            name: 'data-participant'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                } else {
                  

                    this.$axios.post("/participant", body, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Create User Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();

                        this.$router.push({
                            name: 'data-participant'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                }
            }
        },
        mounted() {

            if (this.edit) {
                this.getDetail()
            }

        }
    }
</script>